diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/motd.c ircd-hybrid-fuis/src/motd.c
--- ircd-hybrid-7.0rc9/src/motd.c	Thu Oct 10 14:49:30 2002
+++ ircd-hybrid-fuis/src/motd.c	Sun Feb  9 08:21:21 2003
@@ -50,6 +50,7 @@
     motd->motdType = motdType;
     motd->contentsOfFile = NULL;
     motd->lastChangedDate[0] = '\0';
+	motd->linecount = 0;
   }
 
 /*
@@ -119,7 +120,6 @@
         }
       sendto_one(source_p,":%s NOTICE %s :Start of OPER MOTD",me.name,source_p->name);
       break;
-
     default:
       return 0;
       /* NOT REACHED */
@@ -173,6 +173,7 @@
     }
 
   MessageFileptr->contentsOfFile = NULL;
+  MessageFileptr->linecount = 0;
   if(stat(MessageFileptr->fileName, &sb) < 0)
     return -1;
 
@@ -199,7 +200,7 @@
 
       strlcpy(newMessageLine->line, buffer, sizeof(newMessageLine->line));
       newMessageLine->next = (MessageFileLine *)NULL;
-
+	  MessageFileptr->linecount++;
       if(MessageFileptr->contentsOfFile)
         {
           if (currentMessageLine)
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_bsd_devpoll.c ircd-hybrid-fuis/src/s_bsd_devpoll.c
--- ircd-hybrid-7.0rc9/src/s_bsd_devpoll.c	Tue Nov 26 22:46:57 2002
+++ ircd-hybrid-fuis/src/s_bsd_devpoll.c	Sat Mar 22 18:55:33 2003
@@ -300,5 +300,6 @@
 /**
  * Don't let an empty compilation unit slip through.
  */
-static int dummy;
+//static int dummy;
 #endif /* USE_DEVPOLL */
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_bsd_kqueue.c ircd-hybrid-fuis/src/s_bsd_kqueue.c
--- ircd-hybrid-7.0rc9/src/s_bsd_kqueue.c	Tue Nov 26 22:46:57 2002
+++ ircd-hybrid-fuis/src/s_bsd_kqueue.c	Sat Mar 22 18:55:33 2003
@@ -290,5 +290,5 @@
 /**
  * Don't let an empty compilation unit slip through.
  */
-static int dummy;
+//static int dummy;
 #endif /* USE_KQUEUE */
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_bsd_select.c ircd-hybrid-fuis/src/s_bsd_select.c
--- ircd-hybrid-7.0rc9/src/s_bsd_select.c	Tue Nov 26 22:46:57 2002
+++ ircd-hybrid-fuis/src/s_bsd_select.c	Sat Mar 22 18:55:33 2003
@@ -223,5 +223,5 @@
 /**
  * Don't let an empty compilation unit slip through.
  */
-static int dummy;
+//static int dummy;
 #endif /* USE_SELECT */
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_bsd_sigio.c ircd-hybrid-fuis/src/s_bsd_sigio.c
--- ircd-hybrid-7.0rc9/src/s_bsd_sigio.c	Tue Nov 26 22:46:58 2002
+++ ircd-hybrid-fuis/src/s_bsd_sigio.c	Sat Mar 22 18:55:33 2003
@@ -357,5 +357,5 @@
 /**
  * Don't let an empty compilation unit slip through.
  */
-static int dummy;
+//static int dummy;
 #endif
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_conf.c ircd-hybrid-fuis/src/s_conf.c
--- ircd-hybrid-7.0rc9/src/s_conf.c	Sun Feb 16 17:06:46 2003
+++ ircd-hybrid-fuis/src/s_conf.c	Sat Mar 22 18:55:33 2003
@@ -46,7 +46,6 @@
 #include "s_bsd.h"
 #include "s_log.h"
 #include "send.h"
-#include "s_gline.h"
 #include "s_debug.h"
 #include "fileio.h"
 #include "memory.h"
@@ -94,6 +93,20 @@
 
 #define IP_HASH_SIZE 0x1000
 
+struct Equiv {
+  char *nick;
+  char *target;
+  struct Equiv *next;
+};
+
+static struct Equiv *equivs = NULL;
+static struct Equiv *userparms = NULL;
+
+struct DCCForb {
+  char *fileext;
+  struct DCCForb *next;
+};
+
 struct ip_entry
 {
 #ifndef IPV6
@@ -119,6 +132,10 @@
 /* conf xline link list root */
 struct ConfItem        *x_conf = ((struct ConfItem *)NULL);
 
+static struct DCCForb *dccforb = NULL;
+
+static struct DCCForb *quitcheck = NULL;
+
 /* conf uline link list root */
 struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
 
@@ -517,7 +534,6 @@
 verify_access(struct Client* client_p, const char* username)
 {
   struct ConfItem* aconf;
-  struct ConfItem* gkill_conf;
   char non_ident[USERLEN + 1];
 
   if (IsGotId(client_p))
@@ -545,26 +561,6 @@
 			 aconf->name ? aconf->name : "", aconf->port);
 	      return(NOT_AUTHORIZED);
 	    }
-	  if (ConfigFileEntry.glines)
-	    {
-	      if (!IsConfExemptKline(aconf) && !IsConfExemptGline(aconf))
-		{
-		  if (IsGotId(client_p))
-		    gkill_conf = find_gkill(client_p, client_p->username);
-		  else
-		    gkill_conf = find_gkill(client_p, non_ident);
-
-		  if (gkill_conf)
-		    {
-		      sendto_one(client_p, ":%s NOTICE %s :*** G-lined", me.name,
-				 client_p->name);
-		      sendto_one(client_p, ":%s NOTICE %s :*** Banned %s",
-				 me.name, client_p->name, 
-				 gkill_conf->passwd);
-		      return(BANNED_CLIENT);
-		    }
-		}
-	    }
 	  if (IsConfDoIdentd(aconf))
 	    SetNeedId(client_p);
 	  if (IsConfRestricted(aconf))
@@ -572,6 +568,7 @@
 	  /* Thanks for spoof idea amm */
 	  if (IsConfDoSpoofIp(aconf))
 	    {
+          char *p = strchr(aconf->name, '@');
 #ifndef HIDE_SPOOF_IPS
 	      if (IsConfSpoofNotice(aconf))
 		{
@@ -580,9 +577,25 @@
 				       client_p->host, aconf->name);
 		}
 #endif
-	      strlcpy(client_p->host, aconf->name, sizeof(client_p->host));
-	      SetIPSpoof(client_p);
-	    }
+          if (p)
+        {
+          int len = p - aconf->name;
+          if (len > USERLEN)
+            len = USERLEN;
+
+          strcpy(client_p->realhost, client_p->username);
+          strcat(client_p->realhost, "@");
+          strncat(client_p->realhost, client_p->host, HOSTLEN - strlen(client_p->username) - 1);
+          strncpy(client_p->username, aconf->name, len);
+          if (len)
+            client_p->username[len] = '\0';
+        }
+          else
+        strcpy(client_p->realhost, client_p->host);
+          strncpy(client_p->host, p? p+1 : aconf->name, HOSTLEN);
+
+          SetIPSpoof(client_p);
+        }
 	  return(attach_iline(client_p, aconf));
 	}
       else if (aconf->status & CONF_KILL)
@@ -1392,11 +1405,12 @@
   ConfigFileEntry.true_no_oper_flood = NO;
   ConfigFileEntry.fname_userlog[0] = '\0';
   ConfigFileEntry.fname_foperlog[0] = '\0';
+  ConfigFileEntry.services_host = NULL;
+  ConfigFileEntry.services_qline = NULL;
+  ConfigFileEntry.network_server_site = NULL;
   ConfigFileEntry.fname_operlog[0] = '\0';
-  ConfigFileEntry.glines = NO;
   ConfigFileEntry.use_egd = NO;
   /* don't reset msglocale setting -- we'd overwrite then env string */
-  ConfigFileEntry.gline_time = 12 * 3600;
   ConfigFileEntry.idletime = 0;
   ConfigFileEntry.dots_in_ident = 0;
   ConfigFileEntry.maximum_links = MAXIMUM_LINKS_DEFAULT;
@@ -1422,6 +1436,8 @@
     FLAGS_OPERWALL | FLAGS_WALLOP;
   ConfigFileEntry.oper_only_umodes = FLAGS_DEBUG;
   ConfigFileEntry.throttle_time = 10;
+  ConfigFileEntry.how_old = (5 * 7 * 24 * 60 * 60);
+  ConfigFileEntry.drone_reason[0] = '\0';
 
   ConfigChannel.vchans_oper_only = NO;
 
@@ -1444,6 +1460,14 @@
   ConfigServerHide.hide_servers = 0;
   ConfigServerHide.disable_remote = 0;
   ConfigServerHide.links_delay = 300;
+  ConfigFileEntry.grace_time = 10;
+  ConfigFileEntry.drone_rate_max = 3;
+  ConfigFileEntry.repeat_grace = 20;
+  ConfigFileEntry.drone_rate_period = 20;
+  ConfigFileEntry.drone_kline_time = 300*60;
+  ConfigFileEntry.drone_batch = YES;
+  ConfigFileEntry.drone_kline = YES;
+
   ConfigServerHide.hidden = 0;
   ConfigServerHide.disable_hidden = 0;
 
@@ -1455,6 +1479,8 @@
   ConfigFileEntry.fallback_to_ip6_int = 1;
 #endif
 
+  ConfigFileEntry.silence_default = 0;
+  ConfigFileEntry.no_colors_quit_msg = 1;
 #ifdef EFNET
   ConfigFileEntry.use_help = 0;
 #else
@@ -1745,15 +1771,6 @@
   privs_ptr = privs_out;
   *privs_ptr = '\0';
 
-  if (port & CONF_OPER_GLINE)
-    {
-      if(client_p)
-        SetOperGline(client_p);
-      *privs_ptr++ = 'G';
-    }
-  else
-    *privs_ptr++ = 'g';
-
   if(port & CONF_OPER_K)
     {
       if(client_p)
@@ -1790,6 +1807,12 @@
   else
     *privs_ptr++ = 'r';
   
+  if(port & CONF_OPER_OPERWALL)
+    {
+     if (client_p)
+      SetOperOperwall(client_p);
+    }
+  
   if(port & CONF_OPER_UNKLINE)
     {
       if(client_p)
@@ -1881,6 +1904,14 @@
     *flags_ptr++ = 'l';
   if(flags & FLAGS_CALLERID)
     *flags_ptr++ = 'g';
+  if(flags & FLAGS_SILENCE)
+    *flags_ptr++ = 'S';
+  if(flags & FLAGS_NOLIST)
+    *flags_ptr++ = 'X';
+  if(flags & FLAGS_NODCC)
+    *flags_ptr++ = 'D';
+  if(flags & FLAGS_AVFH)
+    *flags_ptr++ = 'h';
   *flags_ptr = '\0';
 
   return(flags_out);
@@ -2062,6 +2093,7 @@
   struct ConfItem **tmp = &ConfigItemList;
   struct ConfItem *tmp2;
   struct Class    *cltmp;
+  struct DCCForb *fileextf;
 
   /*
    * We only need to free anything allocated by yyparse() here.
@@ -2119,6 +2151,46 @@
   MyFree(ServerInfo.network_desc);
   ServerInfo.network_desc = NULL;
 #ifdef HAVE_LIBCRYPTO
+
+    {
+      struct Equiv *eitem;
+
+      if (equivs) do {
+    eitem = equivs;
+    equivs = equivs->next;
+
+    MyFree(eitem->nick);
+    MyFree(eitem->target);
+    MyFree(eitem);
+
+      } while (equivs);
+
+  if (userparms)
+	do {
+	  eitem = userparms;
+	  userparms = userparms->next;
+
+      MyFree(eitem->nick);
+	  MyFree(eitem->target);
+  	  MyFree(eitem);
+  } while (userparms);
+
+  if (dccforb)
+	do {
+	  fileextf = dccforb;
+	  dccforb = dccforb->next;
+      MyFree(fileextf->fileext);
+  	  MyFree(fileextf);
+  } while (dccforb);
+
+  if (quitcheck)
+	do {
+	  fileextf = quitcheck;
+	  quitcheck = quitcheck->next;
+      MyFree(fileextf->fileext);
+  	  MyFree(fileextf);
+  } while (quitcheck);
+
   if (ServerInfo.rsa_private_key != NULL)
   {
     RSA_free(ServerInfo.rsa_private_key);
@@ -2129,6 +2201,7 @@
     MyFree(ServerInfo.rsa_private_key_file);
     ServerInfo.rsa_private_key_file = NULL;
   }
+}
 #endif
 
   /* clean out old resvs from the conf */
@@ -2517,3 +2590,162 @@
 {
   return(0);
 }
+
+/* USER constant parameter handling
+ *                        -demond
+ */
+
+void add_userpar_param(char *param)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+  if (!param[0]) return;
+
+  DupString(buf, param);
+  p = strchr(buf, '/');
+
+  eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+  if (p) {
+
+    *p = 0; ++p;
+    DupString(q, buf);
+	eitem->nick = q;
+
+    if (*p) {
+
+      DupString(q, p); eitem->target = q;
+    }
+
+  } else {
+
+    DupString(q, buf); eitem->nick = q;
+  }
+  eitem->next = userparms;
+  userparms = eitem;
+
+  MyFree(buf);
+}
+
+int IsUserPar(char *host, char *server)
+{
+  struct Equiv *eitem;
+
+  for (eitem = userparms; eitem; eitem = eitem->next)
+    if (strcmp(host, eitem->nick) == 0)
+	{
+	  if (eitem->target) {
+	    if (strcmp(server, eitem->target) == 0)
+		{
+		  return 1;
+		}
+  	  } else {
+		return 1;
+	  }
+	}
+
+  return 0;
+}
+
+/* DCC Sending arbitration */
+
+void add_dccforb_fileext(char *param)
+{
+  struct DCCForb *fileextf;
+
+  if (!param[0]) return;
+
+  fileextf = (struct DCCForb*) MyMalloc(sizeof(struct DCCForb));
+  DupString(fileextf->fileext, param);
+  fileextf->next = dccforb;
+  dccforb = fileextf;
+}
+
+int IsDCCForb(char *file)
+{
+  struct DCCForb *fileextf;
+
+  for (fileextf = dccforb; fileextf; fileextf = fileextf->next)
+    if (match(fileextf->fileext, file))
+	  return 1;
+
+  return 0;
+}
+
+void add_adv_text(char *param)
+{
+  struct DCCForb *fileextf;
+
+  if (!param[0]) return;
+
+  fileextf = (struct DCCForb*) MyMalloc(sizeof(struct DCCForb));
+  DupString(fileextf->fileext, param);
+  fileextf->next = quitcheck;
+  quitcheck = fileextf;
+}
+
+int IsAdvQuit(char *file)
+{
+  struct DCCForb *fileextf;
+
+  for (fileextf = quitcheck; fileextf; fileextf = fileextf->next)
+    if (match(fileextf->fileext, file))
+	  return 1;
+
+  return 0;
+}
+
+/* these deal with the equivalent nicks stuff
+ *                                  -demond
+ */
+
+void report_equivs(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(RPL_EQUIVALENTS),
+           me.name, source_p->name,
+           eitem->nick, eitem->target);
+}
+
+void add_equiv_nicks(char *nicks)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  DupString(buf, nicks);
+  p = strchr(buf, '/');
+
+  if (p) {
+    *p = 0; ++p;
+
+    if (*p) {
+
+      eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+      DupString(q, buf); eitem->nick = q;
+      DupString(q, p); eitem->target = q;
+
+      eitem->next = equivs;
+      equivs = eitem;
+    }
+  }
+
+  MyFree(buf);
+}
+
+char *get_equiv_nick(char *nick, char *target)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    if (irccmp(nick, eitem->nick) == 0) {
+
+      strncpy(target, eitem->target, NICKLEN);
+      return target;
+    }
+
+  return NULL;
+}
+
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_log.c ircd-hybrid-fuis/src/s_log.c
--- ircd-hybrid-7.0rc9/src/s_log.c	Sat Feb 15 11:32:46 2003
+++ ircd-hybrid-fuis/src/s_log.c	Sun Apr 13 12:18:57 2003
@@ -216,7 +216,8 @@
 	  (signed long) on_for / 3600,
 	  (signed long) (on_for % 3600)/60,
 	  (signed long) on_for % 60,
-	  source_p->name, source_p->username, source_p->host,
+	  source_p->name, source_p->username,
+      source_p->realhost[0]? strcmp(source_p->realhost, "<no_realhost_info>") source_p->realhost : source_p->host : source_p->host,
 	  source_p->localClient->sendK,
 	  source_p->localClient->receiveK);
     }
@@ -250,7 +251,8 @@
 		   (signed long) on_for / 3600,
 		   (signed long) (on_for % 3600)/60,
 		   (signed long) on_for % 60,
-		   source_p->name, source_p->username, source_p->host,
+		   source_p->name, source_p->username,
+	       source_p->realhost[0]? strcmp(source_p->realhost, "<no_realhost_info>") ? source_p->realhost : source_p->host : source_p->host,
 		   source_p->localClient->sendK,
 		   source_p->localClient->receiveK);
 	
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_misc.c ircd-hybrid-fuis/src/s_misc.c
--- ircd-hybrid-7.0rc9/src/s_misc.c	Fri May 24 19:34:51 2002
+++ ircd-hybrid-fuis/src/s_misc.c	Sat Mar 22 18:55:33 2003
@@ -27,17 +27,23 @@
 #include "client.h"
 #include "common.h"
 #include "irc_string.h"
+#include "list.h"
 #include "ircd.h"
 #include "numeric.h"
 #include "res.h"
+#include "event.h"
 #include "fdlist.h"
 #include "s_bsd.h"
 #include "s_conf.h"
 #include "s_serv.h"
 #include "send.h"
 #include "memory.h"
+#include "s_log.h"
+#include "s_conf.h"
 
-
+static char *drones[DRONEMAX];
+static int droneidx = 0;
+static void drone_kline(char *ip);
 
 static char* months[] = {
   "January",   "February", "March",   "April",
@@ -120,5 +126,105 @@
   tmptr = localtime(&lclock);
   strftime(timebuffer, MAX_DATE_STRING, "%Y%m%d", tmptr);
   return timebuffer;
+}
+
+/*
+ * possible drones warning/kline, which havent set user->known flag
+ *                                               -demond
+ */
+void check_warn_drone(void *blah)
+{
+  struct Client *cptr;
+
+  for (cptr = GlobalClientList; cptr; cptr = cptr->next)
+    if (MyClient(cptr) && IsPerson(cptr))
+      if (cptr->user && !cptr->user->known)
+	    if (cptr->tsinfo + ConfigFileEntry.grace_time < CurrentTime) {
+          cptr->user->known = 1;
+          if (ConfigFileEntry.drone_kline) {
+            if (ConfigFileEntry.drone_batch) {
+              if (droneidx < DRONEMAX)
+                DupString(drones[droneidx++], cptr->localClient->sockhost);
+            } else
+              drone_kline(cptr->localClient->sockhost);
+          } else
+		    sendto_realops_flags(FLAGS_ALL, L_ALL, "\002WARNING!\002 -- %s (%s@%s) is a possible trojan drone",
+            					   cptr->name, cptr->username, cptr->host);
+	  }
+  eventAdd("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME);
+}
+
+void check_drone_queue(void *blah)
+{
+    int i;
+
+    if (droneidx > ConfigFileEntry.drone_rate_max)
+        for (i=0; i < droneidx; i++)
+            drone_kline(drones[i]);
+
+    for (i=0; i < droneidx; i++)
+        MyFree(drones[i]);
+    droneidx = 0;
+
+    eventAdd("check_drone_queue", check_drone_queue, NULL, ConfigFileEntry.drone_rate_period);
+}
+
+static
+void drone_kline(char *ip)
+{
+  char buf[0x200];
+  struct ConfItem *aconf;
+
+  if (find_conf_name(&temporary_klines, ip, CONF_KILL))
+      return;
+
+  aconf = make_conf();
+  aconf->status = CONF_KILL;
+  DupString(aconf->host, ip);
+  DupString(aconf->user, "*");
+  aconf->port = 0;
+
+  ircsprintf(buf, "Temporary K-line %d min. - %s (%s)",
+      ConfigFileEntry.drone_kline_time/60,
+      ConfigFileEntry.drone_reason[0]?
+      ConfigFileEntry.drone_reason : "possible trojan drone",
+      smalldate(0));
+  DupString(aconf->passwd, buf);
+
+  aconf->hold = CurrentTime + ConfigFileEntry.drone_kline_time;
+
+  add_temp_kline(aconf);
+
+  sendto_realops_flags(FLAGS_ALL, L_ALL,
+     "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60,
+     aconf->user, aconf->host, "possible trojan drone");
+
+  ilog(L_TRACE, "<ircd> added temporary %d min. K-Line for [%s@%s] [%s]",
+     ConfigFileEntry.drone_kline_time/60,
+     aconf->user, aconf->host, "possible trojan drone");
+
+  check_klines();
+}
+
+void purge_repeats(void *blah)
+{
+  dlink_node *ptr, *rep, *next_ptr;
+
+  for (ptr = lclient_list.head; ptr; ptr = ptr->next) {
+    struct Client *cptr = ptr->data;
+
+    for (rep = cptr->user->repeat.head; rep; rep = next_ptr) {
+      struct Repeat *repeatptr = rep->data;
+      next_ptr = rep->next;
+      if (repeatptr->lastphrase + ConfigFileEntry.repeat_grace < CurrentTime) {
+        MyFree(repeatptr->text); MyFree(repeatptr);
+        dlinkDelete(rep, &cptr->user->repeat);
+        free_dlink_node(rep);
+      }
+    }
+  }
+
+  eventAdd("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace);
 }
 
diff -uNrd -x doc -x help ircd-hybrid-7.0rc9/src/s_serv.c ircd-hybrid-fuis/src/s_serv.c
--- ircd-hybrid-7.0rc9/src/s_serv.c	Sat Feb 15 11:32:46 2003
+++ ircd-hybrid-fuis/src/s_serv.c	Sun Apr 13 12:18:57 2003
@@ -72,6 +72,8 @@
 
 int MaxConnectionCount = 1;
 int MaxClientCount     = 1;
+int MaxIdentUsers      = 0;
+int CurrentIdentUsers  = 0;
 int refresh_user_links = 0;
 
 struct Client *uplink=NULL;
@@ -97,13 +99,13 @@
   { "IE",    CAP_IE },
   { "EOB",   CAP_EOB },
   { "KLN",   CAP_KLN },
-  { "GLN",   CAP_GLN },
   { "KNOCK", CAP_KNOCK },
   { "HOPS",  CAP_HOPS },
   { "HUB",   CAP_HUB },
   { "AOPS",  CAP_AOPS },
   { "UID",   CAP_UID },
   { "ZIP",   CAP_ZIP },
+  { "MASK",  CAP_HOSTMASK },
   { "TBURST", CAP_TBURST },
   { "PARA",  CAP_PARA },
   { 0,           0 }
@@ -818,21 +820,34 @@
   }
  
   if (HasID(target_p) && IsCapable(client_p, CAP_UID))
-	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s :%s",
+	  sendto_one(client_p, "CLIENT %s %d %lu %s %s %s %s %s %s :%s",
 				 target_p->name,
 				 target_p->hopcount + 1,
 				 (unsigned long) target_p->tsinfo,
 				 ubuf,
 				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->user->id, target_p->info);
+				 target_p->user->server, target_p->user->id, 
+				 IsCapable(client_p, CAP_HOSTMASK)?
+				 target_p->realhost[0] ? target_p->realhost : "" : "",
+				 target_p->info);
   else
-	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s :%s",
+	  sendto_one(client_p, "NICK %s %d %lu %s %s %s %s %s :%s",
 				 target_p->name, 
 				 target_p->hopcount + 1,
 				 (unsigned long) target_p->tsinfo,
 				 ubuf,
 				 target_p->username, target_p->host,
-				 target_p->user->server, target_p->info);
+				 target_p->user->server,
+				 IsCapable(client_p, CAP_HOSTMASK) ?
+                 target_p->realhost[0] ? target_p->realhost : "" : "",
+                 target_p->info);
+
+  if (IsNSId(target_p))
+    sendto_one(client_p, "SERVID %s NS 1 %ld", target_p->name, target_p->ns_reg ? target_p->ns_reg : time(NULL));
+  if (IsOSId(target_p))
+    sendto_one(client_p, "SERVID %s OS 1", target_p->name);
+  if (IsNetKeeper(target_p))
+   sendto_one(client_p, "SERVID %s NK 1", target_p->name);
 }
 
 /*
